commit:     79a2b605acc121f0b66bac53abf5b8c3e5c9aab2
Author:     Stefan Cristian B. <stefan.cristian+git <AT> rogentos <DOT> ro>
AuthorDate: Sun May 18 10:59:04 2025 +0000
Commit:     Viorel Munteanu <ceamac <AT> gentoo <DOT> org>
CommitDate: Mon May 19 11:29:11 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=79a2b605

dev-util/pycharm-{community,professional}: bump 2024.3.5 & 2025.1

Signed-off-by: Stefan Cristian B. <stefan.cristian+git <AT> rogentos.ro>
Part-of: https://github.com/gentoo/gentoo/pull/41940
Closes: https://github.com/gentoo/gentoo/pull/41940
Signed-off-by: Viorel Munteanu <ceamac <AT> gentoo.org>

 dev-util/pycharm-community/Manifest                |   4 +
 .../pycharm-community-2024.3.5.ebuild              | 232 +++++++++++++++++++++
 .../pycharm-community-2025.1.ebuild                | 232 +++++++++++++++++++++
 dev-util/pycharm-professional/Manifest             |   4 +
 .../pycharm-professional-2024.3.5.ebuild           | 232 +++++++++++++++++++++
 .../pycharm-professional-2025.1.ebuild             | 232 +++++++++++++++++++++
 6 files changed, 936 insertions(+)

diff --git a/dev-util/pycharm-community/Manifest 
b/dev-util/pycharm-community/Manifest
index 138e4f5ecb6a..b609ec72a65b 100644
--- a/dev-util/pycharm-community/Manifest
+++ b/dev-util/pycharm-community/Manifest
@@ -5,3 +5,7 @@ DIST pycharm-community-2024.2.1-aarch64.tar.gz 650975601 
BLAKE2B 0cb3ad78e3ce2e8
 DIST pycharm-community-2024.2.1.tar.gz 651275184 BLAKE2B 
aded074688b368b5d19ad74ff525377a90a64e10a7b61253029ba272923473028a06956a257e0ce255cf00e247de5217f4d6f51396b05eb39622283c8b6da346
 SHA512 
5bb6d535ca50b293d039a748ad58c301d38c61c93c10b72fb054a2b511f0608f7aa308f1fd8738dc7102de6eacaadbb8a5ad96edd053c9600bfc6d787b7c13e6
 DIST pycharm-community-2024.3.2-aarch64.tar.gz 788018356 BLAKE2B 
e0a2f4b55308c8e6e7804459e90df32f7c5263ade69572f7047eac90ffff13ceb1aead712b06e992bb0ddd1133d7aa29466245cf4578cb574db814ea4a33f268
 SHA512 
1e99d8df26cc6bdcfa15e9157ddb7c3f9d33a5e7b8ad5e3949805aa4fac7d79e4cc25c63e6fe7b4007acffd9ccdde2d145b9660ac250c3ede4085f8b58932ef0
 DIST pycharm-community-2024.3.2.tar.gz 787792271 BLAKE2B 
55f6c93b7c5c335f08b544241dc1b17d00d099bb20e21898a1f769dcad535976cdc34bcf5b9d6bcca378437df3900cf2dfd4deb7348172a627c6a0045407d3f7
 SHA512 
2fa0478c5ab0c26438eeb68fde334914d1f0fa51e862a4790a6e0a35517aa28690351d821bfe20defdd34e97e6b6a3364470d63bab5f651f1b48a07beb6a463f
+DIST pycharm-community-2024.3.5-aarch64.tar.gz 790439656 BLAKE2B 
0587331e80b21b59b009fa63f2a5bd06bd1c699e3c7d7817bbcba8fe09acfa4c54bb3355a379789e53a0f0be1587a6f8ab5e08176dc0936bd267b88c754990e9
 SHA512 
c6a8018e2e9502d3f85873eaef1e9fea900833472701b5bc76c1839128734c5e5d1766a3e2ce554acebedfe920f7a3dd596f9915fc2f75f5055c467dc2cedc8a
+DIST pycharm-community-2024.3.5.tar.gz 790231632 BLAKE2B 
e8a0ff864134c076e00123669bcb1cea4ae1af3e2f5168015f7a587a7f0ab0f9e057f094cba4511f8a8f52a71677913707b81f3caaed7cfa4fed5281457ac317
 SHA512 
3d62e105f064889172e5cc04abae90f0b2b0544fa553349019047a2c9e15b2bf995eb0c9af36465f8b68c85df53749b0042d056d26463f720fae62391a489eeb
+DIST pycharm-community-2025.1-aarch64.tar.gz 857339099 BLAKE2B 
15f1427b1be575279f20d803f93de3f7fa5a48c35e5cc2a1f9d843010a0189f452b10ac27eec396311a94a14b967f774ba485f9629282115082d20d18f078237
 SHA512 
e803f72c563da1990d3bbb9e56440185d0bd467ef7c96ba204ec33c7ec2d127e23f2a4547514e4c8fd47b25a3de95abd90ac327cfce6cd0d7a84b7fd73f3cefb
+DIST pycharm-community-2025.1.tar.gz 859398876 BLAKE2B 
29d30532e66e5156705e8b74df21d11e2fa94ccba4b77f7b47636298cb4366d55273c14e52e2fb63b0850bf06d972ddb7daa10397bedcded36985046c58d6340
 SHA512 
5cd08c23c0db612dd02ef0e79039085bec642a668b373360ca4d9f9e5bd06ba419b8e6d0d242f9b6941c49498944b6601eae59c286deb2e8137399f1606408e9

diff --git a/dev-util/pycharm-community/pycharm-community-2024.3.5.ebuild 
b/dev-util/pycharm-community/pycharm-community-2024.3.5.ebuild
new file mode 100644
index 000000000000..83adbf2f6d92
--- /dev/null
+++ b/dev-util/pycharm-community/pycharm-community-2024.3.5.ebuild
@@ -0,0 +1,232 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit desktop readme.gentoo-r1 toolchain-funcs wrapper xdg
+
+DESCRIPTION="Intelligent Python IDE with unique code assistance and analysis"
+
+# NOTE upstream release info
+# 
https://data.services.jetbrains.com/products?code=PCP,PCC&release.type=release
+# 
https://data.services.jetbrains.com/products?code=PCP,PCC&release.type=release&fields=name,releases
+
+HOMEPAGE="https://www.jetbrains.com/pycharm/";
+SRC_URI="
+       amd64? (
+               https://download.jetbrains.com/python/${P}.tar.gz
+       )
+       arm64? (
+               https://download.jetbrains.com/python/${P}-aarch64.tar.gz
+       )
+       x86? (
+               https://download.jetbrains.com/python/${P}.tar.gz
+       )
+"
+
+if [[ ${PN} == *-professional ]]; then
+       S="${WORKDIR}/${PN/%-professional/}-${PV}"
+       LICENSE="|| ( JetBrains-business JetBrains-classroom 
JetBrains-educational JetBrains-individual )
+       Apache-2.0 BSD BSD-2 CC0-1.0 CC-BY-2.5 CC-BY-3.0 CC-BY-4.0 CPL-1.0 CDDL 
CDDL-1.1 EPL-1.0 EPL-2.0
+       GPL-2 GPL-2-with-classpath-exception ISC JDOM LGPL-2.1 LGPL-3 MIT 
MPL-1.1 MPL-2.0 OFL-1.1
+       PYTHON Unicode-DFS-2016 Unlicense UPL-1.0 ZLIB"
+else
+       LICENSE="|| ( JetBrains-business JetBrains-classroom 
JetBrains-educational JetBrains-individual )
+       Apache-2.0 BSD BSD-2 CC0-1.0 CC-BY-2.5 CC-BY-3.0 CPL-1.0 CDDL-1.1 
EPL-1.0 GPL-2
+       GPL-2-with-classpath-exception ISC JDOM JSON LGPL-2+ LGPL-2.1 LGPL-3 
MIT MPL-1.1 MPL-2.0
+       OFL-1.1 UPL-1.0 ZLIB"
+fi
+
+SLOT="0/2024"
+KEYWORDS="-* ~amd64 ~arm64 ~x86"
+IUSE="+bundled-jdk"
+
+if [[ ${PN} == *-professional ]]; then
+       IUSE+=" +bundled-xvfb"
+fi
+
+BDEPEND="dev-util/debugedit
+       dev-util/patchelf
+"
+
+# NOTE
+#  The remote-dev-server present in pycharm-professional contains most of the
+#  libraries need for the bundled jdk. These are not in the RUNPATH of the jdk.
+#  So the dependencies are actually needed.
+RDEPEND="
+       !bundled-jdk? (
+               >=virtual/jre-17:*
+       )
+       bundled-jdk? (
+               app-accessibility/at-spi2-core:2
+               dev-libs/expat
+               dev-libs/glib:2
+               dev-libs/nspr
+               dev-libs/nss
+               dev-libs/wayland
+               media-libs/alsa-lib
+               media-libs/freetype
+               media-libs/mesa
+               net-print/cups
+               sys-apps/dbus
+               sys-libs/zlib
+               x11-libs/cairo
+               x11-libs/libX11
+               x11-libs/libXcomposite
+               x11-libs/libXcursor
+               x11-libs/libXdamage
+               x11-libs/libXext
+               x11-libs/libXfixes
+               x11-libs/libXi
+               x11-libs/libXrandr
+               x11-libs/libXrender
+               x11-libs/libXtst
+               x11-libs/libXxf86vm
+               x11-libs/libdrm
+               x11-libs/libxcb
+               x11-libs/libxkbcommon
+               x11-libs/pango
+       )
+"
+
+if [[ ${PN} == *-professional ]]; then
+RDEPEND+="
+       bundled-xvfb? (
+               dev-libs/libpcre2
+               sys-libs/pam
+               sys-process/audit
+       )
+       !bundled-xvfb? (
+               x11-base/xorg-server[xvfb]
+       )
+"
+fi
+
+QA_PREBUILT="opt/${PN}/*"
+
+src_prepare() {
+       tc-export OBJCOPY
+       default
+
+       rm -v "${S}"/help/ReferenceCardForMac.pdf || die
+       rm -v 
"${S}"/plugins/python-ce/helpers/pydev/_pydevd_{bundle,frame_eval}/*{darwin,win32}*
 || die
+
+       if ! use amd64; then
+               rm -v  
"${S}"/plugins/python-ce/helpers/pydev/pydevd_attach_to_process/attach_linux_amd64.so
 || die
+               if [[ -d "${S}"/lib/async-profiler/ ]]; then
+                       rm -v  
"${S}"/lib/async-profiler/amd64/libasyncProfiler.so || die
+               fi
+       fi
+       if ! use arm64; then
+               rm -v  
"${S}"/plugins/python-ce/helpers/pydev/pydevd_attach_to_process/attach_linux_aarch64.so
 || die
+               if [[ -d "${S}"/lib/async-profiler/ ]]; then
+                       rm -v  
"${S}"/lib/async-profiler/aarch64/libasyncProfiler.so || die
+               fi
+       fi
+       if ! use x86; then
+               rm -v  
"${S}"/plugins/python-ce/helpers/pydev/pydevd_attach_to_process/attach_linux_x86.so
 || die
+       fi
+
+       sed -i \
+               -e "\$a\\\\" \
+               -e 
"\$a#-----------------------------------------------------------------------" \
+               -e "\$a# Disable automatic updates as these are handled through 
Gentoo's" \
+               -e "\$a# package manager. See bug #704494" \
+               -e 
"\$a#-----------------------------------------------------------------------" \
+               -e "\$aide.no.platform.update=Gentoo" bin/idea.properties
+
+       # excepting files from different architectures that should be kept for 
remote plugins
+       if ! use arm64; then
+               local skip_remote_files=(
+                       
"plugins/platform-ijent-impl/ijent-aarch64-unknown-linux-musl-release"
+                       
"plugins/clion-radler/DotFiles/linux-musl-arm64/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-arm/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-musl-arm/jb_zip_unarchiver"
+                       
"plugins/gateway-plugin/lib/remote-dev-workers/remote-dev-worker-linux-arm64"
+               )
+       elif ! use amd64 ; then
+               local skip_remote_files=(
+                       
"plugins/platform-ijent-impl/ijent-x86_64-unknown-linux-musl-release"
+                       
"plugins/clion-radler/DotFiles/linux-musl-x64/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-x86/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-musl-x86/jb_zip_unarchiver"
+                       
"plugins/gateway-plugin/lib/remote-dev-workers/remote-dev-worker-linux-x64"
+               )
+       fi
+       # removing debug symbols and relocating debug files as per #876295
+       # we're escaping all the files that contain $() in their name
+       # as they should not be executed
+       find . -type f ! -name '*$(*)*' -print0 | while IFS= read -r -d '' 
file; do
+               for skip in "${skip_remote_files[@]}"; do
+                       [[ ${file} == "./${skip}" ]] && continue 2
+               done
+               if file "${file}" | grep -qE "ELF (32|64)-bit"; then
+                       ${OBJCOPY} --remove-section .note.gnu.build-id 
"${file}" || die
+                       debugedit -b "${EPREFIX}/opt/${PN}" -d "/usr/lib/debug" 
-i "${file}" || die
+               fi
+       done
+
+       if use bundled-jdk; then
+               patchelf --set-rpath '$ORIGIN/../lib' "jbr/bin/"* || die
+               patchelf --set-rpath '$ORIGIN' 
"jbr/lib/"{libjcef.so,jcef_helper} || die
+               patchelf --set-rpath '$ORIGIN:$ORIGIN/server' jbr/lib/lib*.so* 
|| die
+       else
+               rm -r "jbr" || die
+       fi
+
+       if [[ ${PN} == *-professional ]]; then
+               if use bundled-xvfb; then
+                       patchelf --set-rpath '$ORIGIN/../lib' 
"${S}"/plugins/remote-dev-server/selfcontained/bin/{Xvfb,xkbcomp} || die
+                       patchelf --set-rpath '$ORIGIN' 
"${S}"/plugins/remote-dev-server/selfcontained/lib/lib*.so* || die
+               else
+                       rm -vr "${S}"/plugins/remote-dev-server/selfcontained 
|| die
+                       sed '/export REMOTE_DEV_SERVER_IS_NATIVE_LAUNCHER/a 
export REMOTE_DEV_SERVER_USE_SELF_CONTAINED_LIBS=1' \
+                         -i bin/remote-dev-server.sh || die
+               fi
+       fi
+}
+
+src_configure() {
+       :;
+}
+
+src_compile() {
+       :;
+}
+
+src_install() {
+       local DIR="/opt/${PN}"
+       local JRE_DIR="jbr"
+
+       insinto "${DIR}"
+       doins -r ./*
+
+       fperms 755 
"${DIR}"/bin/{format.sh,fsnotifier,inspect.sh,jetbrains_client.sh,ltedit.sh,pycharm,pycharm.sh,restarter}
+
+       if use bundled-jdk; then
+               fperms 755 
"${DIR}/${JRE_DIR}"/bin/{java,javac,javadoc,jcmd,jdb,jfr,jhsdb,jinfo,jmap,jps,jrunscript,jstack,jstat,jwebserver,keytool,rmiregistry,serialver}
+               fperms 755 
"${DIR}"/"${JRE_DIR}"/lib/{cef_server,chrome-sandbox,jcef_helper,jexec,jspawnhelper}
+       fi
+
+       if [[ ${PN} == *-professional ]]; then
+               if use bundled-xvfb; then
+                       fperms 755 
"${DIR}"/plugins/remote-dev-server/selfcontained/bin/{Xvfb,xkbcomp}
+               fi
+               fperms 755 "${DIR}" "${DIR}"/bin/remote-dev-server{,.sh}
+       fi
+
+       # we have to strip files that are not related to the current 
architecture
+       dostrip -x "${skip_remote_files[@]/#//opt/${PN}/}"
+
+       make_wrapper "${PN}" "${DIR}/bin/pycharm"
+       newicon "bin/${PN/%-*/}.png" "${PN}.png"
+       make_desktop_entry "${PN}" "${PN}" "${PN}"
+
+       readme.gentoo_create_doc
+
+       # recommended by: 
https://confluence.jetbrains.com/display/IDEADEV/Inotify+Watches+Limit
+       dodir /usr/lib/sysctl.d
+       cat > "${ED}/usr/lib/sysctl.d/30-${PN}-inotify-watches.conf" <<-EOF || 
die
+               fs.inotify.max_user_watches = 524288
+       EOF
+}

diff --git a/dev-util/pycharm-community/pycharm-community-2025.1.ebuild 
b/dev-util/pycharm-community/pycharm-community-2025.1.ebuild
new file mode 100644
index 000000000000..16587e4d9a41
--- /dev/null
+++ b/dev-util/pycharm-community/pycharm-community-2025.1.ebuild
@@ -0,0 +1,232 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit desktop readme.gentoo-r1 toolchain-funcs wrapper xdg
+
+DESCRIPTION="Intelligent Python IDE with unique code assistance and analysis"
+
+# NOTE upstream release info
+# 
https://data.services.jetbrains.com/products?code=PCP,PCC&release.type=release
+# 
https://data.services.jetbrains.com/products?code=PCP,PCC&release.type=release&fields=name,releases
+
+HOMEPAGE="https://www.jetbrains.com/pycharm/";
+SRC_URI="
+       amd64? (
+               https://download.jetbrains.com/python/${P}.tar.gz
+       )
+       arm64? (
+               https://download.jetbrains.com/python/${P}-aarch64.tar.gz
+       )
+       x86? (
+               https://download.jetbrains.com/python/${P}.tar.gz
+       )
+"
+
+if [[ ${PN} == *-professional ]]; then
+       S="${WORKDIR}/${PN/%-professional/}-${PV}"
+       LICENSE="|| ( JetBrains-business JetBrains-classroom 
JetBrains-educational JetBrains-individual )
+       Apache-2.0 BSD BSD-2 CC0-1.0 CC-BY-2.5 CC-BY-3.0 CC-BY-4.0 CPL-1.0 CDDL 
CDDL-1.1 EPL-1.0 EPL-2.0
+       GPL-2 GPL-2-with-classpath-exception ISC JDOM LGPL-2.1 LGPL-3 MIT 
MPL-1.1 MPL-2.0 OFL-1.1
+       PYTHON Unicode-DFS-2016 Unlicense UPL-1.0 ZLIB"
+else
+       LICENSE="|| ( JetBrains-business JetBrains-classroom 
JetBrains-educational JetBrains-individual )
+       Apache-2.0 BSD BSD-2 CC0-1.0 CC-BY-2.5 CC-BY-3.0 CPL-1.0 CDDL-1.1 
EPL-1.0 GPL-2
+       GPL-2-with-classpath-exception ISC JDOM JSON LGPL-2+ LGPL-2.1 LGPL-3 
MIT MPL-1.1 MPL-2.0
+       OFL-1.1 UPL-1.0 ZLIB"
+fi
+
+SLOT="0/2025"
+KEYWORDS="-* ~amd64 ~arm64 ~x86"
+IUSE="+bundled-jdk"
+
+if [[ ${PN} == *-professional ]]; then
+       IUSE+=" +bundled-xvfb"
+fi
+
+BDEPEND="dev-util/debugedit
+       dev-util/patchelf
+"
+
+# NOTE
+#  The remote-dev-server present in pycharm-professional contains most of the
+#  libraries need for the bundled jdk. These are not in the RUNPATH of the jdk.
+#  So the dependencies are actually needed.
+RDEPEND="
+       !bundled-jdk? (
+               >=virtual/jre-17:*
+       )
+       bundled-jdk? (
+               app-accessibility/at-spi2-core:2
+               dev-libs/expat
+               dev-libs/glib:2
+               dev-libs/nspr
+               dev-libs/nss
+               dev-libs/wayland
+               media-libs/alsa-lib
+               media-libs/freetype
+               media-libs/mesa
+               net-print/cups
+               sys-apps/dbus
+               sys-libs/zlib
+               x11-libs/cairo
+               x11-libs/libX11
+               x11-libs/libXcomposite
+               x11-libs/libXcursor
+               x11-libs/libXdamage
+               x11-libs/libXext
+               x11-libs/libXfixes
+               x11-libs/libXi
+               x11-libs/libXrandr
+               x11-libs/libXrender
+               x11-libs/libXtst
+               x11-libs/libXxf86vm
+               x11-libs/libdrm
+               x11-libs/libxcb
+               x11-libs/libxkbcommon
+               x11-libs/pango
+       )
+"
+
+if [[ ${PN} == *-professional ]]; then
+RDEPEND+="
+       bundled-xvfb? (
+               dev-libs/libpcre2
+               sys-libs/pam
+               sys-process/audit
+       )
+       !bundled-xvfb? (
+               x11-base/xorg-server[xvfb]
+       )
+"
+fi
+
+QA_PREBUILT="opt/${PN}/*"
+
+src_prepare() {
+       tc-export OBJCOPY
+       default
+
+       rm -v "${S}"/help/ReferenceCardForMac.pdf || die
+       rm -v 
"${S}"/plugins/python-ce/helpers/pydev/_pydevd_{bundle,frame_eval}/*{darwin,win32}*
 || die
+
+       if ! use amd64; then
+               rm -v  
"${S}"/plugins/python-ce/helpers/pydev/pydevd_attach_to_process/attach_linux_amd64.so
 || die
+               if [[ -d "${S}"/lib/async-profiler/ ]]; then
+                       rm -v  
"${S}"/lib/async-profiler/amd64/libasyncProfiler.so || die
+               fi
+       fi
+       if ! use arm64; then
+               rm -v  
"${S}"/plugins/python-ce/helpers/pydev/pydevd_attach_to_process/attach_linux_aarch64.so
 || die
+               if [[ -d "${S}"/lib/async-profiler/ ]]; then
+                       rm -v  
"${S}"/lib/async-profiler/aarch64/libasyncProfiler.so || die
+               fi
+       fi
+       if ! use x86; then
+               rm -v  
"${S}"/plugins/python-ce/helpers/pydev/pydevd_attach_to_process/attach_linux_x86.so
 || die
+       fi
+
+       sed -i \
+               -e "\$a\\\\" \
+               -e 
"\$a#-----------------------------------------------------------------------" \
+               -e "\$a# Disable automatic updates as these are handled through 
Gentoo's" \
+               -e "\$a# package manager. See bug #704494" \
+               -e 
"\$a#-----------------------------------------------------------------------" \
+               -e "\$aide.no.platform.update=Gentoo" bin/idea.properties
+
+       # excepting files from different architectures that should be kept for 
remote plugins
+       if ! use arm64; then
+               local skip_remote_files=(
+                       
"plugins/platform-ijent-impl/ijent-aarch64-unknown-linux-musl-release"
+                       
"plugins/clion-radler/DotFiles/linux-musl-arm64/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-arm/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-musl-arm/jb_zip_unarchiver"
+                       
"plugins/gateway-plugin/lib/remote-dev-workers/remote-dev-worker-linux-arm64"
+               )
+       elif ! use amd64 ; then
+               local skip_remote_files=(
+                       
"plugins/platform-ijent-impl/ijent-x86_64-unknown-linux-musl-release"
+                       
"plugins/clion-radler/DotFiles/linux-musl-x64/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-x86/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-musl-x86/jb_zip_unarchiver"
+                       
"plugins/gateway-plugin/lib/remote-dev-workers/remote-dev-worker-linux-x64"
+               )
+       fi
+       # removing debug symbols and relocating debug files as per #876295
+       # we're escaping all the files that contain $() in their name
+       # as they should not be executed
+       find . -type f ! -name '*$(*)*' -print0 | while IFS= read -r -d '' 
file; do
+               for skip in "${skip_remote_files[@]}"; do
+                       [[ ${file} == "./${skip}" ]] && continue 2
+               done
+               if file "${file}" | grep -qE "ELF (32|64)-bit"; then
+                       ${OBJCOPY} --remove-section .note.gnu.build-id 
"${file}" || die
+                       debugedit -b "${EPREFIX}/opt/${PN}" -d "/usr/lib/debug" 
-i "${file}" || die
+               fi
+       done
+
+       if use bundled-jdk; then
+               patchelf --set-rpath '$ORIGIN/../lib' "jbr/bin/"* || die
+               patchelf --set-rpath '$ORIGIN' 
"jbr/lib/"{libjcef.so,jcef_helper} || die
+               patchelf --set-rpath '$ORIGIN:$ORIGIN/server' jbr/lib/lib*.so* 
|| die
+       else
+               rm -r "jbr" || die
+       fi
+
+       if [[ ${PN} == *-professional ]]; then
+               if use bundled-xvfb; then
+                       patchelf --set-rpath '$ORIGIN/../lib' 
"${S}"/plugins/remote-dev-server/selfcontained/bin/{Xvfb,xkbcomp} || die
+                       patchelf --set-rpath '$ORIGIN' 
"${S}"/plugins/remote-dev-server/selfcontained/lib/lib*.so* || die
+               else
+                       rm -vr "${S}"/plugins/remote-dev-server/selfcontained 
|| die
+                       sed '/export REMOTE_DEV_SERVER_IS_NATIVE_LAUNCHER/a 
export REMOTE_DEV_SERVER_USE_SELF_CONTAINED_LIBS=1' \
+                         -i bin/remote-dev-server.sh || die
+               fi
+       fi
+}
+
+src_configure() {
+       :;
+}
+
+src_compile() {
+       :;
+}
+
+src_install() {
+       local DIR="/opt/${PN}"
+       local JRE_DIR="jbr"
+
+       insinto "${DIR}"
+       doins -r ./*
+
+       fperms 755 
"${DIR}"/bin/{format.sh,fsnotifier,inspect.sh,jetbrains_client.sh,ltedit.sh,pycharm,pycharm.sh,restarter}
+
+       if use bundled-jdk; then
+               fperms 755 
"${DIR}/${JRE_DIR}"/bin/{java,javac,javadoc,jcmd,jdb,jfr,jhsdb,jinfo,jmap,jps,jrunscript,jstack,jstat,jwebserver,keytool,rmiregistry,serialver}
+               fperms 755 
"${DIR}"/"${JRE_DIR}"/lib/{cef_server,chrome-sandbox,jcef_helper,jexec,jspawnhelper}
+       fi
+
+       if [[ ${PN} == *-professional ]]; then
+               if use bundled-xvfb; then
+                       fperms 755 
"${DIR}"/plugins/remote-dev-server/selfcontained/bin/{Xvfb,xkbcomp}
+               fi
+               fperms 755 "${DIR}" "${DIR}"/bin/remote-dev-server{,.sh}
+       fi
+
+       # we have to strip files that are not related to the current 
architecture
+       dostrip -x "${skip_remote_files[@]/#//opt/${PN}/}"
+
+       make_wrapper "${PN}" "${DIR}/bin/pycharm"
+       newicon "bin/${PN/%-*/}.png" "${PN}.png"
+       make_desktop_entry "${PN}" "${PN}" "${PN}"
+
+       readme.gentoo_create_doc
+
+       # recommended by: 
https://confluence.jetbrains.com/display/IDEADEV/Inotify+Watches+Limit
+       dodir /usr/lib/sysctl.d
+       cat > "${ED}/usr/lib/sysctl.d/30-${PN}-inotify-watches.conf" <<-EOF || 
die
+               fs.inotify.max_user_watches = 524288
+       EOF
+}

diff --git a/dev-util/pycharm-professional/Manifest 
b/dev-util/pycharm-professional/Manifest
index 058de9c7d7a3..f208bddb77de 100644
--- a/dev-util/pycharm-professional/Manifest
+++ b/dev-util/pycharm-professional/Manifest
@@ -3,3 +3,7 @@ DIST pycharm-professional-2023.3.3-aarch64.tar.gz 817002751 
BLAKE2B 75e43700d727
 DIST pycharm-professional-2023.3.3.tar.gz 816045880 BLAKE2B 
2f967d6aad4ff837da1ed08e74a625c4f59ec9a867f47c112858e7d9d9fb1dcf538da82a4970b7cb0d2e35dfd7f30743ee14aaf2cfadf18fb3db05e5a10f35f8
 SHA512 
f7c32f8608e235f111ffd83573fb60e7efdac5107ec50564d33885b3c5c0ccc37f951c8df139ac8a23fffe92e51a3b487a37648daa4b801f49529f7d761cda2b
 DIST pycharm-professional-2024.3.2-aarch64.tar.gz 1163550105 BLAKE2B 
6e4cad835433d99d12c16c8f6e261b9471721b524690c92df6428bd36fa841da99ac941777130d84bf30ce778d945b783fa59a7d8c17d26c2419ef2146e35901
 SHA512 
27af643e78e17a58108a927607d839bc436c83eaa95846b461ac1cc47623e567a9714312cec9b4b6212074601f7c91ecb133de2122bec2cf109c8275fe221e9c
 DIST pycharm-professional-2024.3.2.tar.gz 1163857060 BLAKE2B 
b30ea1e7467f5fa58ef77df234d62dd5916ab2400faac486deeb8940b6ffb43986e56cb1ba85e3bcff6bdcff25f6ee2b8ccdbe4429f04e45b1e099fc02063b06
 SHA512 
70dbaf542e2c6dd788c1c673449ae238ddf21790dafdb14e38aa42247d5f0f030352bcd4be9e5817a7fdf0941f0d11f4a1247b43257d469d3b783752eb8856f1
+DIST pycharm-professional-2024.3.5-aarch64.tar.gz 1166185264 BLAKE2B 
f37e585130dd3869110195148518e77fc177fff78990b569b25a6031e4fc98eb4f60afdd5436c24bdba7da19f5d6bc3c290c7129632a89db3580f370014e780e
 SHA512 
5599740bc05e774efb5756f62e1a24ac32c78b7f075aeb51dbb0f451bd550b638da2349c21c08ad90159f3cea99a4753f3b6069c9b5968f39f470216b01a2802
+DIST pycharm-professional-2024.3.5.tar.gz 1166498314 BLAKE2B 
d4508f119ed3488393721029212d32ef0293b6c52b3855cc7c48506d2871129db5b7b07cfe170e1af19096678e5969e04502dc057531effb8122dd729e2463bf
 SHA512 
25719db1b87607fa7334706994d47adc2617aaba3a4a7595c145e5f473e4cb414e9fd49449d5074f2fce4090a4e949a4479708fb4f7c079501d4107b97a61147
+DIST pycharm-professional-2025.1-aarch64.tar.gz 1170865274 BLAKE2B 
5f98de7d9f01047cdb7d687e5951626c894f938694708ab16f78b0abca5b3e023105682400e8122ae463e74d80cb1ed160a4736fff5a7390ba8de59f4875e850
 SHA512 
4a4ab54137e5fc30a09699da8625c3e10636f71a453fbc3a274c58e75ebb5610b2c8c69127b355c64f27b00d5d2d3d338f3bd78b99178c48726ed72fdf55e0ed
+DIST pycharm-professional-2025.1.tar.gz 1173493461 BLAKE2B 
58212877389b3f598c1a8dfbe3c3ecec886a6b71abc330daf5af451f7cf25c2f4c890f21ab45eea04b9b0451448a1ef3a09fed40b8736bc519cfdbd17f94fbb9
 SHA512 
48f14a139dab48e13d68034044e813742692ddbc2697bf1c8399d799f7ece120f4ce4e0ebffc3d1aeade28bd8d853ac45552ced46aa6b3b44dde7f969bb9e824

diff --git a/dev-util/pycharm-professional/pycharm-professional-2024.3.5.ebuild 
b/dev-util/pycharm-professional/pycharm-professional-2024.3.5.ebuild
new file mode 100644
index 000000000000..83adbf2f6d92
--- /dev/null
+++ b/dev-util/pycharm-professional/pycharm-professional-2024.3.5.ebuild
@@ -0,0 +1,232 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit desktop readme.gentoo-r1 toolchain-funcs wrapper xdg
+
+DESCRIPTION="Intelligent Python IDE with unique code assistance and analysis"
+
+# NOTE upstream release info
+# 
https://data.services.jetbrains.com/products?code=PCP,PCC&release.type=release
+# 
https://data.services.jetbrains.com/products?code=PCP,PCC&release.type=release&fields=name,releases
+
+HOMEPAGE="https://www.jetbrains.com/pycharm/";
+SRC_URI="
+       amd64? (
+               https://download.jetbrains.com/python/${P}.tar.gz
+       )
+       arm64? (
+               https://download.jetbrains.com/python/${P}-aarch64.tar.gz
+       )
+       x86? (
+               https://download.jetbrains.com/python/${P}.tar.gz
+       )
+"
+
+if [[ ${PN} == *-professional ]]; then
+       S="${WORKDIR}/${PN/%-professional/}-${PV}"
+       LICENSE="|| ( JetBrains-business JetBrains-classroom 
JetBrains-educational JetBrains-individual )
+       Apache-2.0 BSD BSD-2 CC0-1.0 CC-BY-2.5 CC-BY-3.0 CC-BY-4.0 CPL-1.0 CDDL 
CDDL-1.1 EPL-1.0 EPL-2.0
+       GPL-2 GPL-2-with-classpath-exception ISC JDOM LGPL-2.1 LGPL-3 MIT 
MPL-1.1 MPL-2.0 OFL-1.1
+       PYTHON Unicode-DFS-2016 Unlicense UPL-1.0 ZLIB"
+else
+       LICENSE="|| ( JetBrains-business JetBrains-classroom 
JetBrains-educational JetBrains-individual )
+       Apache-2.0 BSD BSD-2 CC0-1.0 CC-BY-2.5 CC-BY-3.0 CPL-1.0 CDDL-1.1 
EPL-1.0 GPL-2
+       GPL-2-with-classpath-exception ISC JDOM JSON LGPL-2+ LGPL-2.1 LGPL-3 
MIT MPL-1.1 MPL-2.0
+       OFL-1.1 UPL-1.0 ZLIB"
+fi
+
+SLOT="0/2024"
+KEYWORDS="-* ~amd64 ~arm64 ~x86"
+IUSE="+bundled-jdk"
+
+if [[ ${PN} == *-professional ]]; then
+       IUSE+=" +bundled-xvfb"
+fi
+
+BDEPEND="dev-util/debugedit
+       dev-util/patchelf
+"
+
+# NOTE
+#  The remote-dev-server present in pycharm-professional contains most of the
+#  libraries need for the bundled jdk. These are not in the RUNPATH of the jdk.
+#  So the dependencies are actually needed.
+RDEPEND="
+       !bundled-jdk? (
+               >=virtual/jre-17:*
+       )
+       bundled-jdk? (
+               app-accessibility/at-spi2-core:2
+               dev-libs/expat
+               dev-libs/glib:2
+               dev-libs/nspr
+               dev-libs/nss
+               dev-libs/wayland
+               media-libs/alsa-lib
+               media-libs/freetype
+               media-libs/mesa
+               net-print/cups
+               sys-apps/dbus
+               sys-libs/zlib
+               x11-libs/cairo
+               x11-libs/libX11
+               x11-libs/libXcomposite
+               x11-libs/libXcursor
+               x11-libs/libXdamage
+               x11-libs/libXext
+               x11-libs/libXfixes
+               x11-libs/libXi
+               x11-libs/libXrandr
+               x11-libs/libXrender
+               x11-libs/libXtst
+               x11-libs/libXxf86vm
+               x11-libs/libdrm
+               x11-libs/libxcb
+               x11-libs/libxkbcommon
+               x11-libs/pango
+       )
+"
+
+if [[ ${PN} == *-professional ]]; then
+RDEPEND+="
+       bundled-xvfb? (
+               dev-libs/libpcre2
+               sys-libs/pam
+               sys-process/audit
+       )
+       !bundled-xvfb? (
+               x11-base/xorg-server[xvfb]
+       )
+"
+fi
+
+QA_PREBUILT="opt/${PN}/*"
+
+src_prepare() {
+       tc-export OBJCOPY
+       default
+
+       rm -v "${S}"/help/ReferenceCardForMac.pdf || die
+       rm -v 
"${S}"/plugins/python-ce/helpers/pydev/_pydevd_{bundle,frame_eval}/*{darwin,win32}*
 || die
+
+       if ! use amd64; then
+               rm -v  
"${S}"/plugins/python-ce/helpers/pydev/pydevd_attach_to_process/attach_linux_amd64.so
 || die
+               if [[ -d "${S}"/lib/async-profiler/ ]]; then
+                       rm -v  
"${S}"/lib/async-profiler/amd64/libasyncProfiler.so || die
+               fi
+       fi
+       if ! use arm64; then
+               rm -v  
"${S}"/plugins/python-ce/helpers/pydev/pydevd_attach_to_process/attach_linux_aarch64.so
 || die
+               if [[ -d "${S}"/lib/async-profiler/ ]]; then
+                       rm -v  
"${S}"/lib/async-profiler/aarch64/libasyncProfiler.so || die
+               fi
+       fi
+       if ! use x86; then
+               rm -v  
"${S}"/plugins/python-ce/helpers/pydev/pydevd_attach_to_process/attach_linux_x86.so
 || die
+       fi
+
+       sed -i \
+               -e "\$a\\\\" \
+               -e 
"\$a#-----------------------------------------------------------------------" \
+               -e "\$a# Disable automatic updates as these are handled through 
Gentoo's" \
+               -e "\$a# package manager. See bug #704494" \
+               -e 
"\$a#-----------------------------------------------------------------------" \
+               -e "\$aide.no.platform.update=Gentoo" bin/idea.properties
+
+       # excepting files from different architectures that should be kept for 
remote plugins
+       if ! use arm64; then
+               local skip_remote_files=(
+                       
"plugins/platform-ijent-impl/ijent-aarch64-unknown-linux-musl-release"
+                       
"plugins/clion-radler/DotFiles/linux-musl-arm64/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-arm/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-musl-arm/jb_zip_unarchiver"
+                       
"plugins/gateway-plugin/lib/remote-dev-workers/remote-dev-worker-linux-arm64"
+               )
+       elif ! use amd64 ; then
+               local skip_remote_files=(
+                       
"plugins/platform-ijent-impl/ijent-x86_64-unknown-linux-musl-release"
+                       
"plugins/clion-radler/DotFiles/linux-musl-x64/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-x86/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-musl-x86/jb_zip_unarchiver"
+                       
"plugins/gateway-plugin/lib/remote-dev-workers/remote-dev-worker-linux-x64"
+               )
+       fi
+       # removing debug symbols and relocating debug files as per #876295
+       # we're escaping all the files that contain $() in their name
+       # as they should not be executed
+       find . -type f ! -name '*$(*)*' -print0 | while IFS= read -r -d '' 
file; do
+               for skip in "${skip_remote_files[@]}"; do
+                       [[ ${file} == "./${skip}" ]] && continue 2
+               done
+               if file "${file}" | grep -qE "ELF (32|64)-bit"; then
+                       ${OBJCOPY} --remove-section .note.gnu.build-id 
"${file}" || die
+                       debugedit -b "${EPREFIX}/opt/${PN}" -d "/usr/lib/debug" 
-i "${file}" || die
+               fi
+       done
+
+       if use bundled-jdk; then
+               patchelf --set-rpath '$ORIGIN/../lib' "jbr/bin/"* || die
+               patchelf --set-rpath '$ORIGIN' 
"jbr/lib/"{libjcef.so,jcef_helper} || die
+               patchelf --set-rpath '$ORIGIN:$ORIGIN/server' jbr/lib/lib*.so* 
|| die
+       else
+               rm -r "jbr" || die
+       fi
+
+       if [[ ${PN} == *-professional ]]; then
+               if use bundled-xvfb; then
+                       patchelf --set-rpath '$ORIGIN/../lib' 
"${S}"/plugins/remote-dev-server/selfcontained/bin/{Xvfb,xkbcomp} || die
+                       patchelf --set-rpath '$ORIGIN' 
"${S}"/plugins/remote-dev-server/selfcontained/lib/lib*.so* || die
+               else
+                       rm -vr "${S}"/plugins/remote-dev-server/selfcontained 
|| die
+                       sed '/export REMOTE_DEV_SERVER_IS_NATIVE_LAUNCHER/a 
export REMOTE_DEV_SERVER_USE_SELF_CONTAINED_LIBS=1' \
+                         -i bin/remote-dev-server.sh || die
+               fi
+       fi
+}
+
+src_configure() {
+       :;
+}
+
+src_compile() {
+       :;
+}
+
+src_install() {
+       local DIR="/opt/${PN}"
+       local JRE_DIR="jbr"
+
+       insinto "${DIR}"
+       doins -r ./*
+
+       fperms 755 
"${DIR}"/bin/{format.sh,fsnotifier,inspect.sh,jetbrains_client.sh,ltedit.sh,pycharm,pycharm.sh,restarter}
+
+       if use bundled-jdk; then
+               fperms 755 
"${DIR}/${JRE_DIR}"/bin/{java,javac,javadoc,jcmd,jdb,jfr,jhsdb,jinfo,jmap,jps,jrunscript,jstack,jstat,jwebserver,keytool,rmiregistry,serialver}
+               fperms 755 
"${DIR}"/"${JRE_DIR}"/lib/{cef_server,chrome-sandbox,jcef_helper,jexec,jspawnhelper}
+       fi
+
+       if [[ ${PN} == *-professional ]]; then
+               if use bundled-xvfb; then
+                       fperms 755 
"${DIR}"/plugins/remote-dev-server/selfcontained/bin/{Xvfb,xkbcomp}
+               fi
+               fperms 755 "${DIR}" "${DIR}"/bin/remote-dev-server{,.sh}
+       fi
+
+       # we have to strip files that are not related to the current 
architecture
+       dostrip -x "${skip_remote_files[@]/#//opt/${PN}/}"
+
+       make_wrapper "${PN}" "${DIR}/bin/pycharm"
+       newicon "bin/${PN/%-*/}.png" "${PN}.png"
+       make_desktop_entry "${PN}" "${PN}" "${PN}"
+
+       readme.gentoo_create_doc
+
+       # recommended by: 
https://confluence.jetbrains.com/display/IDEADEV/Inotify+Watches+Limit
+       dodir /usr/lib/sysctl.d
+       cat > "${ED}/usr/lib/sysctl.d/30-${PN}-inotify-watches.conf" <<-EOF || 
die
+               fs.inotify.max_user_watches = 524288
+       EOF
+}

diff --git a/dev-util/pycharm-professional/pycharm-professional-2025.1.ebuild 
b/dev-util/pycharm-professional/pycharm-professional-2025.1.ebuild
new file mode 100644
index 000000000000..16587e4d9a41
--- /dev/null
+++ b/dev-util/pycharm-professional/pycharm-professional-2025.1.ebuild
@@ -0,0 +1,232 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit desktop readme.gentoo-r1 toolchain-funcs wrapper xdg
+
+DESCRIPTION="Intelligent Python IDE with unique code assistance and analysis"
+
+# NOTE upstream release info
+# 
https://data.services.jetbrains.com/products?code=PCP,PCC&release.type=release
+# 
https://data.services.jetbrains.com/products?code=PCP,PCC&release.type=release&fields=name,releases
+
+HOMEPAGE="https://www.jetbrains.com/pycharm/";
+SRC_URI="
+       amd64? (
+               https://download.jetbrains.com/python/${P}.tar.gz
+       )
+       arm64? (
+               https://download.jetbrains.com/python/${P}-aarch64.tar.gz
+       )
+       x86? (
+               https://download.jetbrains.com/python/${P}.tar.gz
+       )
+"
+
+if [[ ${PN} == *-professional ]]; then
+       S="${WORKDIR}/${PN/%-professional/}-${PV}"
+       LICENSE="|| ( JetBrains-business JetBrains-classroom 
JetBrains-educational JetBrains-individual )
+       Apache-2.0 BSD BSD-2 CC0-1.0 CC-BY-2.5 CC-BY-3.0 CC-BY-4.0 CPL-1.0 CDDL 
CDDL-1.1 EPL-1.0 EPL-2.0
+       GPL-2 GPL-2-with-classpath-exception ISC JDOM LGPL-2.1 LGPL-3 MIT 
MPL-1.1 MPL-2.0 OFL-1.1
+       PYTHON Unicode-DFS-2016 Unlicense UPL-1.0 ZLIB"
+else
+       LICENSE="|| ( JetBrains-business JetBrains-classroom 
JetBrains-educational JetBrains-individual )
+       Apache-2.0 BSD BSD-2 CC0-1.0 CC-BY-2.5 CC-BY-3.0 CPL-1.0 CDDL-1.1 
EPL-1.0 GPL-2
+       GPL-2-with-classpath-exception ISC JDOM JSON LGPL-2+ LGPL-2.1 LGPL-3 
MIT MPL-1.1 MPL-2.0
+       OFL-1.1 UPL-1.0 ZLIB"
+fi
+
+SLOT="0/2025"
+KEYWORDS="-* ~amd64 ~arm64 ~x86"
+IUSE="+bundled-jdk"
+
+if [[ ${PN} == *-professional ]]; then
+       IUSE+=" +bundled-xvfb"
+fi
+
+BDEPEND="dev-util/debugedit
+       dev-util/patchelf
+"
+
+# NOTE
+#  The remote-dev-server present in pycharm-professional contains most of the
+#  libraries need for the bundled jdk. These are not in the RUNPATH of the jdk.
+#  So the dependencies are actually needed.
+RDEPEND="
+       !bundled-jdk? (
+               >=virtual/jre-17:*
+       )
+       bundled-jdk? (
+               app-accessibility/at-spi2-core:2
+               dev-libs/expat
+               dev-libs/glib:2
+               dev-libs/nspr
+               dev-libs/nss
+               dev-libs/wayland
+               media-libs/alsa-lib
+               media-libs/freetype
+               media-libs/mesa
+               net-print/cups
+               sys-apps/dbus
+               sys-libs/zlib
+               x11-libs/cairo
+               x11-libs/libX11
+               x11-libs/libXcomposite
+               x11-libs/libXcursor
+               x11-libs/libXdamage
+               x11-libs/libXext
+               x11-libs/libXfixes
+               x11-libs/libXi
+               x11-libs/libXrandr
+               x11-libs/libXrender
+               x11-libs/libXtst
+               x11-libs/libXxf86vm
+               x11-libs/libdrm
+               x11-libs/libxcb
+               x11-libs/libxkbcommon
+               x11-libs/pango
+       )
+"
+
+if [[ ${PN} == *-professional ]]; then
+RDEPEND+="
+       bundled-xvfb? (
+               dev-libs/libpcre2
+               sys-libs/pam
+               sys-process/audit
+       )
+       !bundled-xvfb? (
+               x11-base/xorg-server[xvfb]
+       )
+"
+fi
+
+QA_PREBUILT="opt/${PN}/*"
+
+src_prepare() {
+       tc-export OBJCOPY
+       default
+
+       rm -v "${S}"/help/ReferenceCardForMac.pdf || die
+       rm -v 
"${S}"/plugins/python-ce/helpers/pydev/_pydevd_{bundle,frame_eval}/*{darwin,win32}*
 || die
+
+       if ! use amd64; then
+               rm -v  
"${S}"/plugins/python-ce/helpers/pydev/pydevd_attach_to_process/attach_linux_amd64.so
 || die
+               if [[ -d "${S}"/lib/async-profiler/ ]]; then
+                       rm -v  
"${S}"/lib/async-profiler/amd64/libasyncProfiler.so || die
+               fi
+       fi
+       if ! use arm64; then
+               rm -v  
"${S}"/plugins/python-ce/helpers/pydev/pydevd_attach_to_process/attach_linux_aarch64.so
 || die
+               if [[ -d "${S}"/lib/async-profiler/ ]]; then
+                       rm -v  
"${S}"/lib/async-profiler/aarch64/libasyncProfiler.so || die
+               fi
+       fi
+       if ! use x86; then
+               rm -v  
"${S}"/plugins/python-ce/helpers/pydev/pydevd_attach_to_process/attach_linux_x86.so
 || die
+       fi
+
+       sed -i \
+               -e "\$a\\\\" \
+               -e 
"\$a#-----------------------------------------------------------------------" \
+               -e "\$a# Disable automatic updates as these are handled through 
Gentoo's" \
+               -e "\$a# package manager. See bug #704494" \
+               -e 
"\$a#-----------------------------------------------------------------------" \
+               -e "\$aide.no.platform.update=Gentoo" bin/idea.properties
+
+       # excepting files from different architectures that should be kept for 
remote plugins
+       if ! use arm64; then
+               local skip_remote_files=(
+                       
"plugins/platform-ijent-impl/ijent-aarch64-unknown-linux-musl-release"
+                       
"plugins/clion-radler/DotFiles/linux-musl-arm64/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-arm/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-musl-arm/jb_zip_unarchiver"
+                       
"plugins/gateway-plugin/lib/remote-dev-workers/remote-dev-worker-linux-arm64"
+               )
+       elif ! use amd64 ; then
+               local skip_remote_files=(
+                       
"plugins/platform-ijent-impl/ijent-x86_64-unknown-linux-musl-release"
+                       
"plugins/clion-radler/DotFiles/linux-musl-x64/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-x86/jb_zip_unarchiver"
+                       
"plugins/clion-radler/DotFiles/linux-musl-x86/jb_zip_unarchiver"
+                       
"plugins/gateway-plugin/lib/remote-dev-workers/remote-dev-worker-linux-x64"
+               )
+       fi
+       # removing debug symbols and relocating debug files as per #876295
+       # we're escaping all the files that contain $() in their name
+       # as they should not be executed
+       find . -type f ! -name '*$(*)*' -print0 | while IFS= read -r -d '' 
file; do
+               for skip in "${skip_remote_files[@]}"; do
+                       [[ ${file} == "./${skip}" ]] && continue 2
+               done
+               if file "${file}" | grep -qE "ELF (32|64)-bit"; then
+                       ${OBJCOPY} --remove-section .note.gnu.build-id 
"${file}" || die
+                       debugedit -b "${EPREFIX}/opt/${PN}" -d "/usr/lib/debug" 
-i "${file}" || die
+               fi
+       done
+
+       if use bundled-jdk; then
+               patchelf --set-rpath '$ORIGIN/../lib' "jbr/bin/"* || die
+               patchelf --set-rpath '$ORIGIN' 
"jbr/lib/"{libjcef.so,jcef_helper} || die
+               patchelf --set-rpath '$ORIGIN:$ORIGIN/server' jbr/lib/lib*.so* 
|| die
+       else
+               rm -r "jbr" || die
+       fi
+
+       if [[ ${PN} == *-professional ]]; then
+               if use bundled-xvfb; then
+                       patchelf --set-rpath '$ORIGIN/../lib' 
"${S}"/plugins/remote-dev-server/selfcontained/bin/{Xvfb,xkbcomp} || die
+                       patchelf --set-rpath '$ORIGIN' 
"${S}"/plugins/remote-dev-server/selfcontained/lib/lib*.so* || die
+               else
+                       rm -vr "${S}"/plugins/remote-dev-server/selfcontained 
|| die
+                       sed '/export REMOTE_DEV_SERVER_IS_NATIVE_LAUNCHER/a 
export REMOTE_DEV_SERVER_USE_SELF_CONTAINED_LIBS=1' \
+                         -i bin/remote-dev-server.sh || die
+               fi
+       fi
+}
+
+src_configure() {
+       :;
+}
+
+src_compile() {
+       :;
+}
+
+src_install() {
+       local DIR="/opt/${PN}"
+       local JRE_DIR="jbr"
+
+       insinto "${DIR}"
+       doins -r ./*
+
+       fperms 755 
"${DIR}"/bin/{format.sh,fsnotifier,inspect.sh,jetbrains_client.sh,ltedit.sh,pycharm,pycharm.sh,restarter}
+
+       if use bundled-jdk; then
+               fperms 755 
"${DIR}/${JRE_DIR}"/bin/{java,javac,javadoc,jcmd,jdb,jfr,jhsdb,jinfo,jmap,jps,jrunscript,jstack,jstat,jwebserver,keytool,rmiregistry,serialver}
+               fperms 755 
"${DIR}"/"${JRE_DIR}"/lib/{cef_server,chrome-sandbox,jcef_helper,jexec,jspawnhelper}
+       fi
+
+       if [[ ${PN} == *-professional ]]; then
+               if use bundled-xvfb; then
+                       fperms 755 
"${DIR}"/plugins/remote-dev-server/selfcontained/bin/{Xvfb,xkbcomp}
+               fi
+               fperms 755 "${DIR}" "${DIR}"/bin/remote-dev-server{,.sh}
+       fi
+
+       # we have to strip files that are not related to the current 
architecture
+       dostrip -x "${skip_remote_files[@]/#//opt/${PN}/}"
+
+       make_wrapper "${PN}" "${DIR}/bin/pycharm"
+       newicon "bin/${PN/%-*/}.png" "${PN}.png"
+       make_desktop_entry "${PN}" "${PN}" "${PN}"
+
+       readme.gentoo_create_doc
+
+       # recommended by: 
https://confluence.jetbrains.com/display/IDEADEV/Inotify+Watches+Limit
+       dodir /usr/lib/sysctl.d
+       cat > "${ED}/usr/lib/sysctl.d/30-${PN}-inotify-watches.conf" <<-EOF || 
die
+               fs.inotify.max_user_watches = 524288
+       EOF
+}


Reply via email to